using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Zadatak5
{
    class Program
    {
        class Cvor
        {
            public int broj1, broj2;
            public string slovo;
            public Cvor levo, desno;
        }
        static Cvor NapraviCvor(int broj1,int broj2,string slovo)
        {
            Cvor novi = new Cvor();
            novi.broj1 = broj1;
            novi.broj2 = broj2;
            novi.slovo = slovo;
            novi.levo = null;
            novi.desno = null;
            return novi;
        }
        static Cvor DodajCvor(Cvor drvo, int broj1, int broj2, string slovo)
        {
            if (drvo == null) 
                return NapraviCvor(broj1, broj2, slovo);
            if (broj1 < drvo.broj1) 
                drvo.levo = DodajCvor(drvo.levo, broj1, broj2, slovo);
            else 
                drvo.desno = DodajCvor(drvo.desno, broj1, broj2, slovo);
            return 
                drvo;
        }

        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int br1 = 0, br2 = 0;
            string s1;
            string[] s = Console.ReadLine().Split();
            br1 = int.Parse(s[0]);
            br2 = int.Parse(s[1]);
            s1 = s[2];
            Cvor cvor = NapraviCvor(br1, br2, s1);
            for (int i = 1; i < n -1; i++)
            {
                s = Console.ReadLine().Split();
                br1 = int.Parse(s[0]);
                br2 = int.Parse(s[1]);
                s1 = s[2];
                cvor = DodajCvor(cvor, br1, br2, s1);
            }
        }
    }
}